import java.io.*;
import java.lang.*;

public class Configfile {

    public void exists ()
    {
        File configfile = new File("../conf/server-config");

        System.out.print ("looking for existing configuration ::: ");

        if ( configfile.exists() )
        {
            System.out.print ("found\n");
        }
        else
        {
            System.out.print ("not found\n");
            System.out.println ("writing default values into configuration file");
            try {
                this.writedefaults(configfile);
            }
            catch (IOException e) {
                System.out.println ("error at writing to configfile");
                System.exit(-1);
            }
        }
    }

    public static void writedefaults (File configfile) throws IOException
    {
        FileWriter out = new FileWriter(configfile);

        out.write ("map=scg01ea\n");
        out.write ("numplayers=2\n");
        out.write ("maxplayers=4\n");
        out.write ("money=5000\n");
        out.write ("techlevel=5\n");
        out.write ("crates=1\n");
        out.write ("ctf=0\n");
        out.write ("port=1995\n");

        out.close();
    }

    public static Values readvalues () throws IOException
    {
        File configfile = new File ("../conf/server-config");
        FileReader in = new FileReader(configfile);
        Values val = new Values();
        int c;
        String linebuffer = "";
        String option = "";
        String value = "";

        while ((c = in.read()) != -1 )
        {

            if (c != 10) // linebreak
            {
                if (c != 61) // gleichzeichen
                {
                    linebuffer = linebuffer + (char)c;
                }
                else
                {
                    option = linebuffer;
                    linebuffer = "";
                }
            }
            else
            {
                value = linebuffer;
                linebuffer = "";
                //System.out.println ("option \"" + option + "\" contains value " + value );

                if (option.compareTo("map") == 0)  { val.map(value); }
                if (option.compareTo("numplayers") == 0)  { val.numplayers(Integer.parseInt(value)); }
                if (option.compareTo("maxplayers") == 0)  { val.maxplayers(Integer.parseInt(value)); }
                if (option.compareTo("money") == 0)  { val.money(Integer.parseInt(value)); }
                if (option.compareTo("techlevel") == 0)  { val.techlevel(Integer.parseInt(value)); }
                if (option.compareTo("crates") == 0)
                {
                    if (value.compareTo("1") == 0)
                    { val.crates(1); }
                    else
                    { val.crates(0); }
                }
                if (option.compareTo("ctf") == 0)
                {
                    if (value.compareTo("1") == 0)
                    { val.ctf(1); }
                    else
                    { val.ctf(0); }
                }
                if (option.compareTo("port") == 0) { val.port(Integer.parseInt(value)); }

            }

        }
        in.close();

        return val;
    }

    public static void showvalues(Values val) {
        System.out.println ("\nChosen Map : " + val.getmap());
        System.out.println ("Minimal Number of Players : " + val.getnumplayers());
        System.out.println ("Maximal Number of Players : " + val.getmaxplayers());
        System.out.println ("Starting Credits : " + val.getmoney());
        System.out.println ("Techlevel : " + val.gettechlevel());
        System.out.println ("Crates available?	: " + val.getcrates());
        System.out.println ("Play Capture the Flag? : " + val.getctf());
        System.out.println ("Serving on Port : " + val.getport() + "\n");
    }




}


