import java.io.*;

public class InitServer{

    public void Init(String[] args) {
        LocalSocket 	locsocket 	= new LocalSocket();
        Info        		info      	= new Info();
        Values      	val2      	= new Values();
        LoadFile    	lf        	= new LoadFile();
        Configfile  	conffile  	= new Configfile();
        Arguments 	argments 	= new Arguments();
        ActionEventQueue AEQ 	= new ActionEventQueue();
        boolean 	erroratStartup 	= false;

        info.printWelcomeMessage();

        if (args.length >= 1) {
            val2.initValues();
            argments.readout(val2, args, info);
            erroratStartup = argments.checkAllParametersChecked(val2, args);
            if (erroratStartup) {
                this.ShutDown();
            }
            else {
                System.out.println ("Using Manually Parameter Configuration");
            }
        }
        else {
            try {
                conffile.exists();
                val2 = conffile.readvalues();
            } catch (IOException e) {}
        }

        lf.loadINI(val2.getmap() + ".ini");
        lf.loadBIN(val2.getmap() + ".bin");

        AEQ.init(); // starting ActionEventQueue

        locsocket.Init(val2, locsocket, AEQ);	// starting socket
    }

    public void ShutDown() {
        System.out.println ("Shutting down server...");

        System.exit(0);
    }


}
