#include "actioneventqueue.h"
#include "memtrack.h"

using namespace std;

/** Constructor, starts the timer */
ActionEventQueue::ActionEventQueue() {
    curtick = 0;
    /* Set up the timer and send the pointer to the curtick to it */
    timer = SDL_AddTimer(30, timercallback, &curtick);
}

/** Destructor, removes the timer and empties the actioneventqueue */
ActionEventQueue::~ActionEventQueue() {
    SDL_RemoveTimer(timer);
    while( !eventqueue.empty() ) {
        delete eventqueue.top();
        eventqueue.pop();
    }
}

/** scedules  event for later ececution.
 * @param a class containing the action to run.
 */
void ActionEventQueue::scheduleEvent(ActionEvent *ev) {
    ev->addCurtick(curtick);
    eventqueue.push(ev);
}

/** Run all events in the actionqueue. */
void ActionEventQueue::runEvents() {
    /* run all events in the queue with a prio lower than curtick */
    while( !eventqueue.empty() && eventqueue.top()->getPrio() <= curtick ) {
        if (eventqueue.top() != NULL) {
            eventqueue.top()->run();
        } else {
            fprintf(stderr,"Warning! NULL AE on queue\n");
        }
        //      delete eventqueue.top();
        eventqueue.pop();
    }
}

/** timercallback function, increases the current tick
 * @param the timerinterval.
 * @param a pointer to the curtick.
 * @returns the time 'til next tick (always the same as the indata) 
 */
Uint32 ActionEventQueue::timercallback(Uint32 interval, void *param) {
    *((Uint32 *)param) = *((Uint32 *)param) + 1;
    return interval;
}
