#ifndef __SELECTION_H
#define __SELECTION_H

#ifdef _MSC_VER
# pragma warning (disable: 4503)
# pragma warning (disable: 4786)
#endif

#include <vector>
#include "SDL.h"

class Unit;
class Structure;
class UnitOrStructure;

class Selection {
public:
    Selection();
    ~Selection();
    void addUnit(Unit *selunit, bool enemy);
    void removeUnit(Unit *selunit);
    void addStructure(Structure *selstruct, bool enemy);
    void removeStructure(Structure *selstruct);

    //   void saveSelection(Uint8 savepos);
    //   void loadSelection(Uint8 loadpos);
    void clearSelection();

    bool canAttack();
    bool canMove();
    bool isEnemy() {
        return enemies_selected;
    }
    bool empty() {
        return sel_units.size() == 0 && sel_structures.size() == 0;
    }
    void moveUnits(Uint16 stop);
    void attackUnit(Unit* target);
    void attackStructure(Structure* target);
    void checkSelection();
    Unit* getRandomUnit();
    bool getWall();
private:
    std::vector<Unit *> sel_units;
    std::vector<Structure *> sel_structures;

    Uint16 numinfantry;
    Uint16 numattacking;
    bool enemies_selected;
    //   static std::vector<Unit *>saved_unitsel[10];
    //   static std::vector<Structure *>saved_structsel[10];
}
;


#endif
